import React, { useState, useEffect } from 'react';
import PropTypes from 'prop-types';
import queryString from 'query-string';
import axios from 'axios';
import jwt_decode from 'jwt-decode';

var qs = require('querystring');

var HLib = /*#__PURE__*/function () {
  function HLib() {}

  var _proto = HLib.prototype;

  _proto.init = function init(props) {
    this.devmode = props.devmode;
    this.window = props.window;
    this.graviteeserver = props.graviteeserver;
    this.graviteedomaine = props.graviteedomaine;
    this.redirecturl = props.redirecturl;
    this.props = props;
  };

  _proto._loginurl = function _loginurl(props) {
    var url = "" + props.graviteeserver + props.graviteedomaine + "/oauth/authorize?client_id=" + props.clientid + "&response_type=code&redirect_uri=" + props.redirecturl;
    return url;
  };

  _proto._tokenurl = function _tokenurl(props) {
    var url = "" + props.graviteeserver + props.graviteedomaine + "/oauth/token";
    return url;
  };

  _proto._tokenurlheader = function _tokenurlheader(props) {
    var config = {
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': "Basic " + props.bearer
      }
    };
    return config;
  };

  _proto._tokenurldata = function _tokenurldata(props) {
    var data2 = {
      grant_type: 'authorization_code',
      code: this.code,
      redirect_uri: props.redirecturl,
      client_id: props.clientid
    };
    console.log('tokenurldata:', qs.stringify(data2));
    return data2;
  };

  _proto._getcode = function _getcode() {
    var parsed = queryString.parse(location.search);
    console.log("LOCATION:", location.search, parsed.code);

    if (parsed.code !== undefined) {
      this.code = parsed.code;
      return parsed.code;
    } else {
      return undefined;
    }
  };

  _proto.apimLogin = function apimLogin() {
    var loginurl = this._loginurl(this.props);

    console.log('APIM Call ==> Go:', self.window, loginurl);

    if (this.devmode == false) {
      this.window.location.href = loginurl;
    }
  };

  _proto.logout = function logout() {
    var url = "" + this.props.graviteeserver + this.props.graviteedomaine + "/logout?invalidate_tokens=true&target_url=" + this.props.redirecturl;
    this.window.location.href = url;
  };

  _proto.getUserToken = function getUserToken() {
    var _this = this;

    var tokenurl = this._tokenurl(this.props);

    var tokenurldata = this._tokenurldata(this.props);

    var tokenurlheader = this._tokenurlheader(this.props);

    var callback = this.props.setReceivedToken;
    console.log('GET USER TOKEN ===> Axios call');
    axios.post(tokenurl, qs.stringify(tokenurldata), tokenurlheader).then(function (res) {
      var jwtObj = res.data.access_token.split('.');
      console.log(jwt_decode(res.data.access_token));

      _this.getUserInfo(jwt_decode(res.data.access_token), res.data.access_token, callback);
    })["catch"](function (err, payload) {
      console.log('ERROR - getUserToken: ', err, payload);

      _this.apimLogin();
    });
  };

  _proto.getUserInfo = function getUserInfo(jwtObj, access_token, callback) {
    if (callback === void 0) {
      callback = undefined;
    }

    var config = {
      headers: {
        'Authorization': "Bearer " + access_token
      }
    };
    var url = jwtObj.iss + "/userinfo";
    axios.get(url, config).then(function (res) {
      console.log('getUserInfo', res.data);
      callback({
        access_token: access_token,
        user_data: res.data
      });
    })["catch"](function (err) {
      console.log('ERROR - getUserToken: ', err);
    });
  };

  return HLib;
}();

var _L = new HLib();

var qs$1 = require('querystring');

var GraviteeLoginComponent = function GraviteeLoginComponent(props) {
  var LogoutButtonComponent = props.customButton;

  var _useState = useState(false),
      setDevMode = _useState[1];

  useEffect(function () {
    console.log(props);

    _L.init(props);

    setDevMode(props.devmode == undefined ? false : props.devmode);

    if (_L._getcode() != undefined) {
      _L.getUserToken();
    } else {
      _L.apimLogin();
    }
  }, []);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    className: props.className != undefined ? props.className : ''
  }, LogoutButtonComponent != undefined && /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      props.logoutCallback();

      _L.logout();
    }
  }, /*#__PURE__*/React.createElement(LogoutButtonComponent, null))));
};
GraviteeLoginComponent.propTypes = {
  code: PropTypes.string,
  redirecturl: PropTypes.string,
  logoutCallback: PropTypes.func,
  customButton: PropTypes.any,
  window: PropTypes.any,
  graviteeserver: PropTypes.string,
  graviteedomaine: PropTypes.string,
  clientid: PropTypes.string,
  bearer: PropTypes.string,
  roles: PropTypes.array,
  appHost: PropTypes.string,
  devmode: PropTypes.bool,
  devmode_data: PropTypes.any,
  className: PropTypes.string
};

export { GraviteeLoginComponent };
//# sourceMappingURL=index.modern.js.map
